package io.kubernetes.client.openapi.models;

import io.kubernetes.client.fluent.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class V1JobConditionBuilder extends io.kubernetes.client.openapi.models.V1JobConditionFluentImpl<io.kubernetes.client.openapi.models.V1JobConditionBuilder> implements io.kubernetes.client.fluent.VisitableBuilder<io.kubernetes.client.openapi.models.V1JobCondition,io.kubernetes.client.openapi.models.V1JobConditionBuilder>{
  public V1JobConditionBuilder() {
    this(false);
  }
  public V1JobConditionBuilder(java.lang.Boolean validationEnabled) {
    this(new V1JobCondition(), validationEnabled);
  }
  public V1JobConditionBuilder(io.kubernetes.client.openapi.models.V1JobConditionFluent<?> fluent) {
    this(fluent, false);
  }
  public V1JobConditionBuilder(io.kubernetes.client.openapi.models.V1JobConditionFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new V1JobCondition(), validationEnabled);
  }
  public V1JobConditionBuilder(io.kubernetes.client.openapi.models.V1JobConditionFluent<?> fluent,io.kubernetes.client.openapi.models.V1JobCondition instance) {
    this(fluent, instance, false);
  }
  public V1JobConditionBuilder(io.kubernetes.client.openapi.models.V1JobConditionFluent<?> fluent,io.kubernetes.client.openapi.models.V1JobCondition instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withLastProbeTime(instance.getLastProbeTime());

    fluent.withLastTransitionTime(instance.getLastTransitionTime());

    fluent.withMessage(instance.getMessage());

    fluent.withReason(instance.getReason());

    fluent.withStatus(instance.getStatus());

    fluent.withType(instance.getType());

    this.validationEnabled = validationEnabled; 
  }
  public V1JobConditionBuilder(io.kubernetes.client.openapi.models.V1JobCondition instance) {
    this(instance,false);
  }
  public V1JobConditionBuilder(io.kubernetes.client.openapi.models.V1JobCondition instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withLastProbeTime(instance.getLastProbeTime());

    this.withLastTransitionTime(instance.getLastTransitionTime());

    this.withMessage(instance.getMessage());

    this.withReason(instance.getReason());

    this.withStatus(instance.getStatus());

    this.withType(instance.getType());

    this.validationEnabled = validationEnabled; 
  }
  io.kubernetes.client.openapi.models.V1JobConditionFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.kubernetes.client.openapi.models.V1JobCondition build() {
    V1JobCondition buildable = new V1JobCondition();
    buildable.setLastProbeTime(fluent.getLastProbeTime());
    buildable.setLastTransitionTime(fluent.getLastTransitionTime());
    buildable.setMessage(fluent.getMessage());
    buildable.setReason(fluent.getReason());
    buildable.setStatus(fluent.getStatus());
    buildable.setType(fluent.getType());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    V1JobConditionBuilder that = (V1JobConditionBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}